<?php
namespace Teknisa\COZ\Controllers;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DTO\Response\Error;

class Coz01200CustoPlanejado extends \Zeedhi\Framework\Controller\Report {

	protected $crudService;
	protected $util;
	protected $dataSourceManager;
	protected $novoCodigo;
	protected $entityManager;
	protected $birtStrategy;
	protected $Coz01000ConsumoPlanejado;

	public function __construct(ReportService $reportService, $crudService, $util, $novoCodigo, $entityManager, $birtStrategy, $Coz01000ConsumoPlanejado) {
		$this->crudService    	= $crudService;
		$this->util             = $util;
		$this->novoCodigo    	= $novoCodigo;
		$this->entityManager    = $entityManager;
		$this->birtStrategy     = $birtStrategy;
		$this->Coz01000ConsumoPlanejado = $Coz01000ConsumoPlanejado;
		
		parent::__construct($reportService);
    }
	
	protected $reportMapping = array (
      'cus01200' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'DTINICIAL'       => 'P_DTINI',
                'DTFINAL'         => 'P_DTFIN',
                'CDCENTRAL'       => 'P_CDCENTRAL',
                'NRLISTA'         => 'P_NRLISTA',
                'CDTIPOCUSTOPLA'  => 'P_NRTIPOCUSTOPLAN',
                'NRCONSPLAN'      => 'P_NRCONSPLAN',
                'ORDENA'          => 'P_ORDENA',
                'CDPICTPROD'      => 'P_CDPICTPROD',
                'CDARVPRODINI'    => 'P_CDARVPRODINI',
                'CDARVPRODFIN'    => 'P_CDARVPRODFIN',
                'NRORG'           => 'P_NRORG'
            )
        ),
        'cus01203' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'DTINICIAL'       => 'P_DTINI',
                'DTFINAL'         => 'P_DTFIN',
                'CDCENTRAL'       => 'P_CDCENTRAL',
                'NRLISTA'         => 'P_NRLISTA',
                'CDTIPOCUSTOPLA'  => 'P_NRTIPOCUSTOPLAN',
                'NRCONSPLAN'      => 'P_NRCONSPLAN',
                'ORDENA'          => 'P_ORDENA',
                'CDPICTPROD'      => 'P_CDPICTPROD',
                'CDARVPRODINI'    => 'P_CDARVPRODINI',
                'CDARVPRODFIN'    => 'P_CDARVPRODFIN',
                'NRORG'           => 'P_NRORG'
            )
        ),
        'cus01201' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'DTINICIAL'       => 'P_DTINI',
                'DTFINAL'         => 'P_DTFIN',
                'CDCENTRAL'       => 'P_CDCENTRAL',
                'NRLISTA'         => 'P_NRLISTA',
                'CDTIPOCUSTOPLA'  => 'P_NRTIPOCUSTOPLAN',
                'NRCONSPLAN'      => 'P_NRCONSPLAN',
                'ORDENA'          => 'P_ORDENA',
                'CDPICTPROD'      => 'P_CDPICTPROD',
                'CDARVPRODINI'    => 'P_CDARVPRODINI',
                'CDARVPRODFIN'    => 'P_CDARVPRODFIN',
                'NRORG'           => 'P_NRORG'
            )
        ),
        'cus01204' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'DTINICIAL'       => 'P_DTINI',
                'DTFINAL'         => 'P_DTFIN',
                'CDCENTRAL'       => 'P_CDCENTRAL',
                'NRLISTA'         => 'P_NRLISTA',
                'CDTIPOCUSTOPLA'  => 'P_NRTIPOCUSTOPLAN',
                'NRCONSPLAN'      => 'P_NRCONSPLAN',
                'ORDENA'          => 'P_ORDENA',
                'CDPICTPROD'      => 'P_CDPICTPROD',
                'CDARVPRODINI'    => 'P_CDARVPRODINI',
                'CDARVPRODFIN'    => 'P_CDARVPRODFIN',
                'NRORG'           => 'P_NRORG'
            )
        ),
        'cus01202' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'DTINICIAL'       => 'P_DTINI',
                'DTFINAL'         => 'P_DTFIN',
                'CDCENTRAL'       => 'P_CDCENTRAL',
                'NRLISTA'         => 'P_NRLISTA',
                'CDTIPOCUSTOPLA'  => 'P_NRTIPOCUSTOPLAN',
                'NRCONSPLAN'      => 'P_NRCONSPLAN',
                'ORDENA'          => 'P_ORDENA',
                'CDPICTPROD'      => 'P_CDPICTPROD',
                'CDARVPRODINI'    => 'P_CDARVPRODINI',
                'CDARVPRODFIN'    => 'P_CDARVPRODFIN',
                'NRORG'           => 'P_NRORG'
            )
        )
    );
	
	public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response){
	    try{
	        
	        $row = $request->getRow();

    	    if(empty($row['NMSERVFILI'])) $row['NMSERVFILI'] = $this->Coz01000ConsumoPlanejado->filtraServicos($row);
	    	
    	    $row['NRLISTA'] = $this->Coz01000ConsumoPlanejado->gerarListaServ($row['NMSERVFILI'], $row['NRORG']);
    
    	    $nrListaConsplan = $this->Coz01000ConsumoPlanejado->gerarLista($row['NMSERVFILI'], $row['NRORG']);

    	    $cdprodini = empty($row['CDARVPRODINI']) ? '0' : $row['CDARVPRODINI'];
            if(empty($row['CDARVPRODFIN'])) $cdprodfin = 'Z';
            else $cdprodfin = str_pad($row['CDARVPRODFIN'], 10, "Z", STR_PAD_RIGHT);
            
            $row['CDARVPRODINI'] = $cdprodini;
            $row['CDARVPRODFIN'] = $cdprodfin;
            
    	    $row['NRCONSPLAN'] = $this->Coz01000ConsumoPlanejado->gerarNrConsplan($nrListaConsplan, $row);
    	    $this->birtStrategy->setReportFormat(strtolower($row['QR2TYPE']));
	    }catch(\Exception $e){
	        $response->setError(new Error($e->getMessage(), 500));
	    }
	}
}